# sample_five.py

import os
import array

import wx
import wx.adv

# class MyPanel
# class MyThankDlg
# class MyFrame
# class MyApp

#-------------------------------------------------------------------------------

class MyPanel(wx.Panel):   
    """
    ...    
    """
    def __init__(self, parent, size):
        wx.Panel.__init__(self, parent, -1, size=size)

        #------------
        
        self.parent = parent
        
        #------------

        w, h = self.GetClientSize()
        
        # Initial y position of image.
        self.y = h

        #------------

        self.timer = wx.Timer(self)
        # Start(int milliseconds, oneShot=False).
        # Lower timer interval gives faster speed.
        self.timer.Start(10) 

        #------------
      
        self.height = 50 

        self.MakeBitmapRGBA(w+100, self.height)   # width, height for gradient. 
        self.MakeBitmapRGBA_(w+100, self.height)   # width, height for gradient.

        #------------
        
        # Simplified init method.
        self.SetProperties()
        self.CreateCtrls()
        self.BindEvents()
         
    #---------------------------------------------------------------------------

    def SetProperties(self):
        """
        Set the properties.
        """

        self.SetBackgroundStyle(wx.BG_STYLE_CUSTOM)


    def CreateCtrls(self):
        """
        ...
        """

        # Load the image.
        self.photo = wx.Bitmap("bitmaps/wxPython.png", wx.BITMAP_TYPE_PNG)

        
    def BindEvents(self):
        """
        Bind all the events related to my panel.
        """

        # Bind the Paint and Size event        
        self.Bind(wx.EVT_SIZE, self.OnResize)
        self.Bind(wx.EVT_PAINT, self.OnPaint)
        self.Bind(wx.EVT_ERASE_BACKGROUND, self.OnErase)        
        self.Bind(wx.EVT_TIMER, self.OnTimer, self.timer)
        # self.Bind(wx.EVT_MOUSE_EVENTS, self.OnMouseEvents)
        
            
    def OnMouseEvents(self, event): 
        """
        ...
        """
        
        if event.LeftDown() :
            self.timer.Stop()
        else:
            self.timer.Start()
        event.Skip()

        
    def OnErase(self, evt):
        """
        Noop because of double buffering.
        """
        
        pass
    
       
    def OnResize(self, event):
        """
        Refresh widget after resizing.
        """

        self.Refresh()
        event.Skip()
        
      
    def GetRGB(self, x, y, bpp):   
        """
        ...
        """
        
        # Calculate some colour values for
        # this sample based on x,y position.
        # 255 = white  |  0 = black 
        r = g = b = 0 

        if bpp == 4:   
            a = int(y * 255.0 / self.height)  

            return r, g, b, a   
        else:   
            return r, g, b   
   
       
    def MakeBitmapRGBA(self, width, height):   
        """
        ...
        """
        
        # Make a bitmap using an array of RGBA bytes. 
        bpp = 4  # Bytes per pixel.  
        bytes = array.array('B', [0] * width*height*bpp)   
   
        for y in range(height):   
            for x in range(width):   
                offset = x*bpp - y*width*bpp 
                r,g,b,a = self.GetRGB(x, y, bpp)   
                bytes[offset + 0] = r   
                bytes[offset + 1] = g   
                bytes[offset + 2] = b   
                bytes[offset + 3] = a   
   
        self.rgbaBmp = wx.Bitmap.FromBufferRGBA(width, height, bytes)   

    
    def MakeBitmapRGBA_(self, width, height):   
        """
        ...
        """
        
        # Make a bitmap using an array of RGBA bytes.  
        bpp = 4  # Bytes per pixel.
        bytes = array.array('B', [0] * width*height*bpp)   
   
        for y in range(height):   
            for x in range(width):   
                offset = y*width*bpp - x*bpp 
                r,g,b,a = self.GetRGB(x, y, bpp)   
                bytes[offset + 0] = r   
                bytes[offset + 1] = g   
                bytes[offset + 2] = b   
                bytes[offset + 3] = a   
   
        self.rgbaBmp_ = wx.Bitmap.FromBufferRGBA(width, height, bytes)   

    
    def DrawBitmapAndMessage(self, dc, bmp, msg, x_, y_):   
        """
        ...
        """
        
        x, y = x_, y_   
   
        dc.DrawText(msg, x, y)   

        # Draw the bitmap over the text.   
        dc.DrawBitmap(bmp, x_, y_, True)

 
    def OnPaint(self, event):   
        """
        ...
        """
        
        dc = wx.BufferedPaintDC(self) 
        brush = wx.Brush("black") 
        dc.SetBackground(brush)
        # or dc.SetBackground(wx.Brush(wx.WHITE))
        dc.Clear()

        #------------
        
        w = self.photo.GetWidth()
        h = self.photo.GetHeight()
        
        width, height = self.GetSize()
        l, h = ((width/2)-(w/2), (height/2)-(h/2))
        
        # Draw the image.
        dc.DrawBitmap(self.photo, int(l), int(h), False)

        #------------

        self.paintBox(dc)


    def OnTimer(self, event):
        """
        ...
        """

        w, h = self.GetClientSize()

        #------------
        
        # Increment x to start moving.
        self.y += -0.5 
        
        # Optional continuous movement
        # experiment with wrap around values.
        if self.y > h or self.y < -500:
            self.y = h
        self.Refresh()
       
        
    def paintBox(self, dc):
        """
        ...
        """
        
        font = dc.GetFont()
        font.SetWeight(wx.BOLD)
        font.SetPointSize(10)
        # font.SetFaceName("Tahoma") 
        dc.SetFont(font)

        #------------
        
        width, height = self.GetClientSize()

        #------------
        
        txt1  = ("Special thanks to :")
        txt2  = ("Vegaseat (DaniWeb)")
        txt3  = ("Mike Driscoll")
        txt4  = ("Robin Dunn")
        txt5  = ("Giuseppe Costanzi")
        txt6  = ("Pascal Faut.")
        txt7  = ("Cody Precord")
        txt8  = ("Andrea Gavana") 
        txt9  = ("Werner F. Bruhin")
        txt10 = ("Robin Rappin") 
        txt11 = ("Chris Barker")
        txt12 = ("Alain Delgrange")
        txt13 = ("ZetCode ") 
        txt14 = ("Steven Sproat")
        txt15 = ("Beppe & Guldo")
        txt16 = ("Ray Pasco")
        txt17 = ("David Hughes")
        txt18 = ("Ianare Sévi")
        txt19 = ("Fenikso")
        txt20 = ("Yvan Lucas")
        txt21 = ("Christoph Gohlke...") 
        txt22 = ("L'équipe des wxWidgets")
        txt23 = ("La communauté python et wxPython")
        txt24 = ("L'ensemble des forums dédiés")

        #------------
        
        wt1, ht1   = dc.GetTextExtent(txt1)
        wt2, ht2   = dc.GetTextExtent(txt2)
        wt3, ht3   = dc.GetTextExtent(txt3)
        wt4, ht4   = dc.GetTextExtent(txt4)
        wt5, ht5   = dc.GetTextExtent(txt5)
        wt6, ht6   = dc.GetTextExtent(txt6)
        wt7, ht7   = dc.GetTextExtent(txt7)
        wt8, ht8   = dc.GetTextExtent(txt8)
        wt9, ht9   = dc.GetTextExtent(txt9)
        wt10, ht10 = dc.GetTextExtent(txt10)
        wt11, ht11 = dc.GetTextExtent(txt11)
        wt12, ht12 = dc.GetTextExtent(txt12)
        wt13, ht13 = dc.GetTextExtent(txt13)
        wt14, ht14 = dc.GetTextExtent(txt14)
        wt15, ht15 = dc.GetTextExtent(txt15)
        wt16, ht16 = dc.GetTextExtent(txt16)
        wt17, ht17 = dc.GetTextExtent(txt17)
        wt18, ht18 = dc.GetTextExtent(txt18)
        wt19, ht19 = dc.GetTextExtent(txt19)
        wt20, ht20 = dc.GetTextExtent(txt20)
        wt21, ht21 = dc.GetTextExtent(txt21)
        wt22, ht22 = dc.GetTextExtent(txt22)
        wt23, ht23 = dc.GetTextExtent(txt23)
        wt24, ht24 = dc.GetTextExtent(txt24)
        
        #------------       

        # Set the text and draw it (txt1).
        dc.SetTextForeground("#ffffff")
        dc.DrawText(txt1, int(width/2-(wt1/2)), int(self.y)) 

        dc.SetPen(wx.Pen('red', 2))
        # Draw a blue line (thickness = 2)
        dc.DrawLine(90, int(self.y+30), width-90, int(self.y+30)) 
        
        dc.SetTextForeground("#ff0084") 
        dc.DrawText(txt2, int(width/2-(wt2/2)), int(self.y+40))        

        dc.SetTextForeground("#ff00bb") 
        dc.DrawText(txt3, int(width/2-(wt3/2)), int(self.y+60))

        dc.SetTextForeground("#ff00fb")  
        dc.DrawText(txt4, int(width/2-(wt4/2)), int(self.y+80))  

        dc.SetTextForeground("#c800ff")  
        dc.DrawText(txt5, int(width/2-(wt5/2)), int(self.y+100)) 

        dc.SetTextForeground("#9000ff") 
        dc.DrawText(txt6, int(width/2-(wt6/2)), int(self.y+120)) 

        dc.SetTextForeground("#5100ff") 
        dc.DrawText(txt7, int(width/2-(wt7/2)), int(self.y+140))  

        dc.SetTextForeground("#2200ff")  
        dc.DrawText(txt8, int(width/2-(wt8/2)), int(self.y+160)) 

        dc.SetTextForeground("#0059ff") 
        dc.DrawText(txt9, int(width/2-(wt9/2)), int(self.y+180)) 

        dc.SetTextForeground("#0095ff")  
        dc.DrawText(txt10, int(width/2-(wt10/2)), int(self.y+200)) 

        dc.SetTextForeground("#00ddff") 
        dc.DrawText(txt11, int(width/2-(wt11/2)), int(self.y+220)) 

        dc.SetTextForeground("#00ffc8") 
        dc.DrawText(txt12, int(width/2-(wt12/2)), int(self.y+240)) 

        dc.SetTextForeground("#00ff11") 
        dc.DrawText(txt13, int(width/2-(wt13/2)), int(self.y+260))

        dc.SetTextForeground("#8cff00")  
        dc.DrawText(txt14, int(width/2-(wt14/2)), int(self.y+280))

        dc.SetTextForeground("#d9ff00") 
        dc.DrawText(txt15, int(width/2-(wt15/2)), int(self.y+300))

        dc.SetTextForeground("#ffe500") 
        dc.DrawText(txt16, int(width/2-(wt16/2)), int(self.y+320)) 

        dc.SetTextForeground("#ffc800")  
        dc.DrawText(txt17, int(width/2-(wt17/2)), int(self.y+340))  

        dc.SetTextForeground("#ff7f00")  
        dc.DrawText(txt18, int(width/2-(wt18/2)), int(self.y+360)) 

        dc.SetTextForeground("#ff5100") 
        dc.DrawText(txt19, int(width/2-(wt19/2)), int(self.y+380)) 

        dc.SetTextForeground("#ff0000")  
        dc.DrawText(txt20, int(width/2-(wt20/2)), int(self.y+400))

        dc.SetTextForeground("#b92f2f")  
        dc.DrawText(txt21, int(width/2-(wt21/2)), int(self.y+420))

        dc.SetTextForeground("#505050")  
        dc.DrawText(txt22, int(width/2-(wt22/2)), int(self.y+440)) 

        dc.SetTextForeground("#787878")  
        dc.DrawText(txt23, int(width/2-(wt23/2)), int(self.y+460)) 

        dc.SetTextForeground("#ffffff")   
        dc.DrawText(txt24, int(width/2-(wt24/2)), int(self.y+480))  
        
        # dc, img alpha, txt, x, y
        # Start and end for gradient.
        self.DrawBitmapAndMessage(dc, self.rgbaBmp, "", 0-100, -1)                                                                        
        self.DrawBitmapAndMessage(dc, self.rgbaBmp_, "", 0-100, height-50+1)

#-------------------------------------------------------------------------------
    
class MyThankDlg(wx.Dialog):
    """
    ...    
    """
    def __init__(self, parent, id, title):
        """
        ...
        """
        wx.Dialog.__init__(self, parent,
                           wx.ID_ANY,
                           title)
        
        #------------
        
        self.parent = parent
        
        #------------
        
        # Simplified init method
        self.SetProperties()
        self.CreateCtrls()
        self.BindEvents()
        self.DoLayout()
           
        #------------
        
        self.Centre(wx.BOTH)

    #---------------------------------------------------------------------------
     
    def SetProperties(self):
        """
        Set the dialog properties (title, icon...).
        """

        # Set frame icon. 
        self.SetIcon(wx.Icon('icons/wxwin.ico'))
        self.SetBackgroundColour(wx.WHITE)
        self.SetTransparent(240)
        self.SetSize((360, 380))
        # self.SetTitle("Thank to...")

        
    def CreateCtrls(self):
        """
        Make some widgets.
        """

        self.panel1 = wx.Panel(self,
                               id=-1,
                               style=wx.BORDER_NONE |
                               wx.TAB_TRAVERSAL)
        self.panel1.SetBackgroundColour(wx.BLACK)

        self.panel2 = wx.Panel(self,
                               id=-1,
                               style=wx.TAB_TRAVERSAL)
        self.panel2.SetBackgroundColour(wx.WHITE)

        w, h = self.GetClientSize()                 

        self.ticker = MyPanel(self.panel1, size=(w, h))

        #------------
     
        self.btnClose = wx.Button(self.panel2,
                                  id=wx.ID_CLOSE,
                                  label="&Close")
        self.btnClose.SetFocus()        

        
    def BindEvents(self):
        """
        Bind all the events related to my panel.
        """

        self.Bind(wx.EVT_BUTTON, self.OnClose, id=wx.ID_CLOSE)
        self.Bind(wx.EVT_CHAR_HOOK, self.OnKeyUp)
        self.Bind(wx.EVT_CLOSE, self.OnClose) 

        
    def DoLayout(self):
        """
        Do layout.
        """

        hBox1 = wx.BoxSizer(wx.HORIZONTAL)
        hBox1.Add(self.ticker, 1, wx.ALL | wx.EXPAND, 5)
        self.panel1.SetSizer(hBox1)

        #------------
        
        hBox2 = wx.BoxSizer(wx.HORIZONTAL)
        hBox2.Add(self.btnClose, 1, wx.BOTTOM | wx.EXPAND, 5)
        self.panel2.SetSizer(hBox2)

        vBox = wx.BoxSizer(wx.VERTICAL)
        vBox.Add(self.panel1, 1, wx.EXPAND | wx.ALL | wx.CENTER, 5)    
        vBox.Add(self.panel2, 0, wx.ALL | wx.CENTER,  5)    

        #------------
        
        self.SetAutoLayout(True)
        self.SetSizer(vBox)

        
    def OnClose(self, event):
        """
        ...    
        """

        self.EndModal(event.GetId())

        
    def OnKeyUp(self, event):
        """
        Handles the wx.EVT_CHAR_HOOK event for the dialog.
        """

        if event.GetKeyCode() == wx.WXK_ESCAPE:
            # Close the dialog, no action.
            self.OnClose(event)

        event.Skip()

#-------------------------------------------------------------------------------

class MyFrame(wx.Frame):
    """
    ...
    """
    def __init__(self):
        super(MyFrame, self).__init__(None,
                                      -1,
                                      title="")

        #------------

        # Simplified init method.
        self.SetProperties()
        self.CreateCtrls()
        self.BindEvents()
        self.DoLayout()

        #------------

        self.CenterOnScreen()

    #-----------------------------------------------------------------------

    def SetProperties(self):
        """
        ...
        """

        self.SetTitle("Sample five")
        self.SetIcon(wx.Icon('icons/wxwin.ico'))


    def CreateCtrls(self):
        """
        ...
        """

        self.panel = wx.Panel(self, -1)

        #------------

        self.btnDlg = wx.Button(self.panel,
                                -1,
                                "&Show customized vertical news-ticker dialog")

        self.btnClose = wx.Button(self.panel,
                                  -1,
                                  "&Close")


    def BindEvents(self):
        """
        Bind some events to an events handler.
        """

        # Bind the close event to an event handler.
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

        # Bind the buttons event to an event handler.
        self.Bind(wx.EVT_BUTTON, self.OnThanksDlg, self.btnDlg)
        self.Bind(wx.EVT_BUTTON, self.OnCloseMe, self.btnClose)


    def DoLayout(self):
        """
        ...
        """

        # mainSizer is the top-level one that manages everything.
        mainSizer = wx.BoxSizer(wx.VERTICAL)

        # wx.BoxSizer(window, proportion, flag, border)
        # wx.BoxSizer(sizer, proportion, flag, border)
        mainSizer.Add(self.btnDlg, 1, wx.EXPAND | wx.ALL, 10)
        mainSizer.Add(self.btnClose, 1, wx.EXPAND | wx.ALL, 10)

        # Finally, tell the panel to use the sizer for layout.
        self.panel.SetAutoLayout(True)
        self.panel.SetSizer(mainSizer)

        mainSizer.Fit(self.panel)


    def OnCloseMe(self, event):
        """
        ...
        """

        self.Close(True)


    def OnThanksDlg(self, event):
        """
        ...
        """

        thanksTo = MyThankDlg(self,
                              id=-1,
                              title="Thanks to...")
        result = thanksTo.ShowWindowModal()

        if result == wx.ID_CLOSE:
             result.Close(True)
             result.Destroy()
             

    def OnCloseWindow(self, event):
        """
        ...
        """

        self.Destroy()

#-------------------------------------------------------------------------------

class MyApp(wx.App):
    """
    ...
    """
    def OnInit(self):

        #------------

        frame = MyFrame()
        self.SetTopWindow(frame)
        frame.Show(True)

        return True

#---------------------------------------------------------------------------

def main():
    app = MyApp(False)
    app.MainLoop()

#---------------------------------------------------------------------------

if __name__ == "__main__" :
    main()
