# sample_six.py

import os
import array

import wx
import wx.adv

# class MyPanel
# class MyThankDlg
# class MyFrame
# class MyApp

#-------------------------------------------------------------------------------

class MyPanel(wx.Panel):   
    """
    ...    
    """
    def __init__(self, parent, size):
        wx.Panel.__init__(self, parent, -1, size=size)

        #------------
        
        self.parent = parent
        
        #------------

        w, h = self.GetClientSize()
        
        # Initial y position of image.
        self.x = w

        #------------

        self.timer = wx.Timer(self)
        # Start(int milliseconds, oneShot=False).
        # Lower timer interval gives faster speed.
        self.timer.Start(10) 

        #------------
      
        self.width = 65 

        self.MakeBitmapRGBA(self.width, h)   # width, height for gradient. 
        self.MakeBitmapRGBA_(self.width, h)   # width, height for gradient.

        #------------
        
        # Simplified init method.
        self.SetProperties()
        self.CreateCtrls()
        self.BindEvents()
         
    #---------------------------------------------------------------------------

    def SetProperties(self):
        """
        Set the properties.
        """

        self.SetBackgroundStyle(wx.BG_STYLE_CUSTOM)


    def CreateCtrls(self):
        """
        ...
        """

        # Load the image.
        self.photo = wx.Bitmap("bitmaps/wxWidgets.png", wx.BITMAP_TYPE_PNG)

        
    def BindEvents(self):
        """
        Bind all the events related to my panel.
        """

        # Bind the Paint and Size event        
        self.Bind(wx.EVT_SIZE, self.OnResize)
        self.Bind(wx.EVT_PAINT, self.OnPaint)
        self.Bind(wx.EVT_ERASE_BACKGROUND, self.OnErase)        
        self.Bind(wx.EVT_TIMER, self.OnTimer, self.timer)
        # self.Bind(wx.EVT_MOUSE_EVENTS, self.OnMouseEvents)
        
            
    def OnMouseEvents(self, event): 
        """
        ...
        """
        
        if event.LeftDown() :
            self.timer.Stop()
        else:
            self.timer.Start()
        event.Skip()

        
    def OnErase(self, evt):
        """
        Noop because of double buffering.
        """
        
        pass
    
       
    def OnResize(self, event):
        """
        Refresh widget after resizing.
        """

        self.Refresh()
        event.Skip()
        
      
    def GetRGB(self, x, y, bpp):   
        """
        ...
        """
        
        # Calculate some colour values for
        # this sample based on x,y position.
        # 255 = white  |  0 = black 
        r = g = b = 255 

        if bpp == 4:   
            a = int(x * 255.0 / self.width)   
            return r, g, b, a   
        else:   
            return r, g, b   
   
       
    def MakeBitmapRGBA(self, width, height):   
        """
        ...
        """
        
        # Make a bitmap using an array of RGBA bytes. 
        bpp = 4  # Bytes per pixel.  
        bytes = array.array('B', [0] * width*height*bpp)   
   
        for y in range(height):   
            for x in range(width):   
                offset = y*width*bpp + x*bpp   
                r,g,b,a = self.GetRGB(x, y, bpp)   
                bytes[offset + 0] = r   
                bytes[offset + 1] = g   
                bytes[offset + 2] = b   
                bytes[offset + 3] = a   
   
        self.rgbaBmp = wx.Bitmap.FromBufferRGBA(width, height, bytes)  

    
    def MakeBitmapRGBA_(self, width, height):   
        """
        ...
        """
        
        # Make a bitmap using an array of RGBA bytes.  
        bpp = 4  # Bytes per pixel.
        bytes = array.array('B', [0] * width*height*bpp)   
   
        for y in range(height):   
            for x in range(width):   
                offset = y*width*bpp - x*bpp   
                r,g,b,a = self.GetRGB(x, y, bpp)   
                bytes[offset + 0] = r   
                bytes[offset + 1] = g   
                bytes[offset + 2] = b   
                bytes[offset + 3] = a   
   
        self.rgbaBmp_ = wx.Bitmap.FromBufferRGBA(width, height, bytes)   

    
    def DrawBitmapAndMessage(self, dc, bmp, msg, x_, y_):   
        """
        ...
        """
        
        x, y = x_, y_   
   
        dc.DrawText(msg, x, y)     

        # Draw the bitmap over the text.   
        dc.DrawBitmap(bmp, x_, y_, True)

 
    def OnPaint(self, event):   
        """
        ...
        """
        
        dc = wx.BufferedPaintDC(self) 
        brush = wx.Brush("white") 
        dc.SetBackground(brush)
        # or dc.SetBackground(wx.Brush(wx.WHITE))
        dc.Clear()

        #------------
        
        w = self.photo.GetWidth()
        h = self.photo.GetHeight()
        
        width, height = self.GetSize()
        l, h = ((width/2)-(w/2), (height/2)-(h/2))
        
        # Draw the image.
        dc.DrawBitmap(self.photo, int(l), int(h), False)

        #------------

        self.paintBox(dc)


    def OnTimer(self, event):
        """
        ...
        """

        w, h = self.GetClientSize()

        #------------
        
        # Increment x to start moving.
        self.x += -0.5 
        
        # Optional continuous movement
        # experiment with wrap around values.
        if self.x > w or self.x < -430:
            self.x = w
        self.Refresh()
       
        
    def paintBox(self, dc):
        """
        ...
        """
        
        font = dc.GetFont()
        font.SetWeight(wx.BOLD)
        font.SetPointSize(10)
        # font.SetFaceName("Tahoma") 
        dc.SetFont(font)

        #------------
        
        width, height = self.GetClientSize()

        #------------
        
        txt  = ("Special thanks to : Vegaseat (DaniWeb), Mike Driscoll, Robin Dunn...")

        #------------
        
        wt, ht   = dc.GetTextExtent(txt)
        
        #------------       

        # Set the text and draw it (txt1).
        dc.SetTextForeground("black")
        dc.DrawText(txt, int(self.x), int(height/2-ht/2))
        
        # dc, img alpha, txt, x, y
        # Start and end for gradient.
        self.DrawBitmapAndMessage(dc, self.rgbaBmp, "", width-65, 0)                                                                       
        self.DrawBitmapAndMessage(dc, self.rgbaBmp_, "", -2, 0)

#-------------------------------------------------------------------------------
    
class MyThankDlg(wx.Dialog):
    """
    ...    
    """
    def __init__(self, parent, id, title):
        """
        ...
        """
        wx.Dialog.__init__(self, parent,
                           wx.ID_ANY,
                           title)
        
        #------------
        
        self.parent = parent
        
        #------------
        
        # Simplified init method
        self.SetProperties()
        self.CreateCtrls()
        self.BindEvents()
        self.DoLayout()
           
        #------------
        
        self.Centre(wx.BOTH)

    #---------------------------------------------------------------------------
     
    def SetProperties(self):
        """
        Set the dialog properties (title, icon...).
        """

        # Set frame icon. 
        self.SetIcon(wx.Icon('icons/wxwin.ico'))
        self.SetBackgroundColour("black")
        self.SetTransparent(240)
        self.SetSize((440, 300))
        # self.SetTitle("Thank to...")

        
    def CreateCtrls(self):
        """
        Make some widgets.
        """

        self.panel1 = wx.Panel(self,
                               id=-1,
                               style=wx.BORDER_NONE |
                               wx.TAB_TRAVERSAL)
        self.panel1.SetBackgroundColour(wx.WHITE)

        self.panel2 = wx.Panel(self,
                               id=-1,
                               style=wx.TAB_TRAVERSAL)
        self.panel2.SetBackgroundColour("black")

        w, h = self.GetClientSize()                 

        self.ticker = MyPanel(self.panel1, size=(w, h))

        #------------
     
        self.btnClose = wx.Button(self.panel2,
                                  id=wx.ID_CLOSE,
                                  label="&Close")
        self.btnClose.SetFocus()        

        
    def BindEvents(self):
        """
        Bind all the events related to my panel.
        """

        self.Bind(wx.EVT_BUTTON, self.OnClose, id=wx.ID_CLOSE)
        self.Bind(wx.EVT_CHAR_HOOK, self.OnKeyUp)
        self.Bind(wx.EVT_CLOSE, self.OnClose) 

        
    def DoLayout(self):
        """
        Do layout.
        """

        hBox1 = wx.BoxSizer(wx.HORIZONTAL)
        hBox1.Add(self.ticker, 1, wx.ALL | wx.EXPAND, 5)
        self.panel1.SetSizer(hBox1)

        #------------
        
        hBox2 = wx.BoxSizer(wx.HORIZONTAL)
        hBox2.Add(self.btnClose, 1, wx.BOTTOM | wx.EXPAND, 5)
        self.panel2.SetSizer(hBox2)

        vBox = wx.BoxSizer(wx.VERTICAL)
        vBox.Add(self.panel1, 1, wx.EXPAND | wx.ALL | wx.CENTER, 5)    
        vBox.Add(self.panel2, 0, wx.ALL | wx.CENTER,  5)    

        #------------
        
        self.SetAutoLayout(True)
        self.SetSizer(vBox)

        
    def OnClose(self, event):
        """
        ...    
        """

        self.EndModal(event.GetId())

        
    def OnKeyUp(self, event):
        """
        Handles the wx.EVT_CHAR_HOOK event for the dialog.
        """

        if event.GetKeyCode() == wx.WXK_ESCAPE:
            # Close the dialog, no action.
            self.OnClose(event)

        event.Skip()

#-------------------------------------------------------------------------------

class MyFrame(wx.Frame):
    """
    ...
    """
    def __init__(self):
        super(MyFrame, self).__init__(None,
                                      -1,
                                      title="")

        #------------

        # Simplified init method.
        self.SetProperties()
        self.CreateCtrls()
        self.BindEvents()
        self.DoLayout()

        #------------

        self.CenterOnScreen()

    #-----------------------------------------------------------------------

    def SetProperties(self):
        """
        ...
        """

        self.SetTitle("Sample six")
        self.SetIcon(wx.Icon('icons/wxwin.ico'))


    def CreateCtrls(self):
        """
        ...
        """

        self.panel = wx.Panel(self, -1)

        #------------

        self.btnDlg = wx.Button(self.panel,
                                -1,
                                "&Show customized horizontal news-ticker dialog")

        self.btnClose = wx.Button(self.panel,
                                  -1,
                                  "&Close")


    def BindEvents(self):
        """
        Bind some events to an events handler.
        """

        # Bind the close event to an event handler.
        self.Bind(wx.EVT_CLOSE, self.OnCloseWindow)

        # Bind the buttons event to an event handler.
        self.Bind(wx.EVT_BUTTON, self.OnThanksDlg, self.btnDlg)
        self.Bind(wx.EVT_BUTTON, self.OnCloseMe, self.btnClose)


    def DoLayout(self):
        """
        ...
        """

        # mainSizer is the top-level one that manages everything.
        mainSizer = wx.BoxSizer(wx.VERTICAL)

        # wx.BoxSizer(window, proportion, flag, border)
        # wx.BoxSizer(sizer, proportion, flag, border)
        mainSizer.Add(self.btnDlg, 1, wx.EXPAND | wx.ALL, 10)
        mainSizer.Add(self.btnClose, 1, wx.EXPAND | wx.ALL, 10)

        # Finally, tell the panel to use the sizer for layout.
        self.panel.SetAutoLayout(True)
        self.panel.SetSizer(mainSizer)

        mainSizer.Fit(self.panel)


    def OnCloseMe(self, event):
        """
        ...
        """

        self.Close(True)


    def OnThanksDlg(self, event):
        """
        ...
        """

        thanksTo = MyThankDlg(self,
                              id=-1,
                              title="Thanks to...")
        result = thanksTo.ShowWindowModal()

        if result == wx.ID_CLOSE:
             result.Close(True)
             result.Destroy()
             

    def OnCloseWindow(self, event):
        """
        ...
        """

        self.Destroy()

#-------------------------------------------------------------------------------

class MyApp(wx.App):
    """
    ...
    """
    def OnInit(self):

        #------------

        frame = MyFrame()
        self.SetTopWindow(frame)
        frame.Show(True)

        return True

#---------------------------------------------------------------------------

def main():
    app = MyApp(False)
    app.MainLoop()

#---------------------------------------------------------------------------

if __name__ == "__main__" :
    main()
